' FileName: FTN2ECO.Bas
' Date: 6/26/2016
' Author: Ben Ritchey
' Description: FIDONet .MSG to Echobase .ECO


#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

FUNCTION PBMAIN () AS LONG

local FPoint, FAdd, FZone, FNet, FNode, FName, INFile, OUTFile as string
local FTo, FSubj, FIFlag, FIntl, FKey, FLine, FFrom, CL, CH, A as string
local L, B, FSize as long
local C as integer
Local PgmVer as String

' Do NOT change format of next line except x-x !!!
  PgmVer=" FTN2ECO v2.0.B "

Startup:
print PgmVer;" {c} 2017  Ben Ritchey"
INFile=command$
if not isfile(INFile) then goto Finished

' convert FSpec to Upper case
for L = 1 to len(INFile)
  A=mid$(INFile,L,1)
  If asc(A)>96 and asc(A)<123 then
    A=chr$(asc(A)-32)
    mid$(INFile,L,1)=A
  end if
next L

B=instr(INFile,".MSG")
If B<2 then goto Finished
A=mid$(INFile,1,B-1)
OUTFile=A+".ECO"
if isfile(OUTFile) then kill OUTFile

open INFile for binary as #1 len=1
FSize=lof(1)
if FSize<191 then goto Finished

Fname=""
for L=1 to 36
  get$ #1,1,A
  if A<>chr$(0) then FName=Fname+A: else L=36
next L

FTo=""
seek #1, 37
for L=1 to 36
  get$ #1,1,A
  if A<>chr$(0) then FTo=FTo+A: else L=36
next L

FSubj=""
seek #1, 73  ' Subject
for L=1 to 72
  get$ #1,1,A
  if A<>chr$(0) then FSubj=FSubj+A: else L=72
next L

seek #1, 169  ' OrigNode Lo/Hi
get$ #1,1,CL
get$ #1,1,CH
FNode=trim$(str$(cvi(CL+CH)))

seek #1, 173  ' OrigNet Lo/Hi
get$ #1,1,CL
get$ #1,1,CH
FNet=trim$(str$(cvi(CL+CH)))

seek #1, 179  ' OrigZone Lo/Hi
get$ #1,1,CL
get$ #1,1,CH
FZone=trim$(str$(cvi(CL+CH)))
if FZone="0" then FZone="1"

seek #1, 183  ' OrigPoint Lo/Hi
get$ #1,1,CL
get$ #1,1,CH
FPoint=trim$(str$(cvi(CL+CH)))

FAdd=FZone+":"+FNet+"/"+FNode
if FPoint<>"0" then FAdd=FAdd+"."+FPoint
FFrom="FROM "+FName+", "+FAdd
FSubj="SUBJ "+FSubj
FTo="TO "+FTo

seek #1, 191  ' Text area
open OUTFile for binary as #2 len=1
print "  Converting ";INFile;" to ";OUTFile

FLine="": FIFlag=""

NextIN:

get$ #1,1,A: if A=chr$(10) or A=chr$(141) then goto NextIN
if A<>chr$(1) then FLine=A: goto Copy1st

' skip kludge
FIntl=""
while not eof(1) and A<>chr$(13)
  get$ #1,1,A
  if A<>chr$(13) then FIntl=FIntl+A
wend

' Premature eof
if eof(1) then goto Finished

' Grab INTL kludge from addy
if mid$(FIntl,1,12)="INTL 1:1/21 " and FIFlag="" then
  print "  Found: "+FIntl
  FFrom="FROM "+FName+", "+mid$(FIntl,13)
  FIFlag="Ok"  ' only do 1st INTL!
end if

goto NextIN

Copy1st:

  if eof(1) then goto Finished
  get$ #1,1,A: if A=chr$(10) or A=chr$(141) then goto Copy1st
  if A=chr$(0) or A=chr$(1) then goto Finished

  if A<>chr$(13) then FLine=FLine+A: goto Copy1st

  if Fline="" then goto Copy1st  ' skip empty line(s) at top

  FKey=mid$(FLine,1,4)
  if FKey="FROM" or FKey="from" or FKey="From" then
    put$ #2,FLine+chr$(13)+chr$(10)
    put$ #2,FTo+chr$(13)+chr$(10)
    put$ #2,FSubj+chr$(13)+chr$(10)
   else
    print "  Adding: "+FFrom  ' 1st line must be "FROM ..."
    put$ #2,FFrom+chr$(13)+chr$(10)
    put$ #2,FTo+chr$(13)+chr$(10)
    put$ #2,FSubj+chr$(13)+chr$(10)
    put$ #2,FLine+chr$(13)+chr$(10)
  end if

' Copy remainder of body
Copyit:
  if eof(1) then goto Finished
  get$ #1,1,A: if A=chr$(10) or A=chr$(141) then goto Copyit
  if A=chr$(0) or A=chr$(1) then goto Finished
  put$ #2,A
' convert to DOS speak
  if A=chr$(13) then put$ #2,chr$(10)
goto Copyit

Finished:

close

ENDITALL:
END FUNCTION
' End of FTN2ECO.Bas